/*
    Copyright (C) 2005-2008  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _DECODER_H_
#define _DECODER_H_

#include "nntpgrab_plugin_base.h"
#include "configuration.h"

typedef struct Decoder Decoder;

#define DECODER_TYPE_OBJECT       (decoder_get_type ())
#define DECODER(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), DECODER_TYPE_OBJECT, Decoder))
#define DECODER_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), DECODER_TYPE_OBJECT, DecoderClass))
#define IS_DECODER(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), DECODER_TYPE_OBJECT))
#define IS_DECODER_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), DECODER_TYPE_OBJECT))
#define DECODER_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), DECODER_TYPE_OBJECT, DecoderClass))

gboolean             decoder_initialize(char **errmsg);
Decoder             *decoder_new(Configuration *config);
void                 decoder_destroy(Decoder *obj);
NNTPGrabDecoderRes   decoder_decode_file(Decoder *obj, const char *collection_name, const NNTPFile *file, int *saved_errno, char **errmsg);

#endif /* _DECODER_H_ */
